Unit qsl4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS13_p;

procedure qsl4e(var RINT :Extended; var A :Extended; var B :Extended;
                F :Func_F1E; var E :Extended; var XA :Extended);

implementation

procedure qsl4e(var RINT :Extended; var A :Extended; var B :Extended;
                F :Func_F1E; var E :Extended; var XA :Extended);
var
N,IL,U,V,X,BK :Integer;
INT,INT2,J1,J,K,L,M,EPS,C,D,O,BA,W,E1,Z2,H,Z1,BH,P,BI,BJ,BF,BG,E2,Q,
E3,R,S,BB,BC,T :Extended;
NI,NIS,Y,Z :Boolean;
BD :Array [0..2] of Extended;
AY :Array [0..6] of Extended;
BY :Array [0..6] of Extended;
KSI :Array [0..6] of Extended;
OM :Array [0..2] of Integer;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50;
begin
{   DATA  FORTRAN  }
AY[0] := 0.023809523809e0;
AY[1] := 0.243809523809e0;
AY[2] := 0.023809523809e0;
AY[3] := 0.138413023681e0;
AY[4] := 0.215872690605e0;
AY[5] := 0.215872690605e0;
AY[6] := 0.138413023681e0;
BY[0] := -0.076190474e0;
BY[1] := 0.243809523809e0;
BY[2] := -0.076190474e0;
BY[3] := 0.183701962e0;
BY[4] := -0.229416249e0;
BY[5] := -0.229416249e0;
BY[6] := 0.183701962e0;
KSI[0] := 0.0e0;
KSI[1] := 0.5e0;
KSI[2] := 1.0e0;
KSI[3] := 0.084888051861e0;
KSI[4] := 0.265575603265e0;
KSI[5] := 0.734424396735e0;
KSI[6] := 0.915111948139e0;
NIS := ( A  > B );
if (  not ( (NIS) ) )
 then goto _1;
BA := A;
A := B;
B := BA;
_1:
V := 2;
Y := True;
EPS := Abs(E);
X := 1;
C := 0;
D := 0;
K := B;
if ( B-100 ) < 0
 then goto _4
 else if ( B-100 ) > 0
       then goto _2
       else goto _2;
_2:
if ( A+100 ) < 0
 then goto _3
 else if ( A+100 ) > 0
       then goto _26
       else goto _3;
_3:
Y := False;
X := -1;
E := E/2;
B := A;
A := 0.e0;
goto _26;
_4:
X := -1;
O := A;
A := B;
B := O;
goto _26;
_5:
NI := ( A  > B );
if (  not ( (NI) ) )
 then goto _6;
BA := A;
A := B;
B := BA;
_6:
W := B-A;
if (  not ( (W  = 0.0e0) ) )
 then goto _7;
J1 := 0;
E1 := 0;
goto _25;
_7:
Z2 := E/W;
H := 1;
Z1 := EPS/W;
P := 0;
E1 := 0;
J1 := 0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_8:
BH := P+H;
BI := 0;
BJ := 0;
for BK:=1 to 3 do
 begin
  if ( OM[BK-1]  = 0 )
   then goto _9;
  BF := BD[BK-1];
  goto _10;
_9:
  BG := H*KSI[BK-1]+P;
  BD[BK-1] := F(W*BG+A);
  BF := BD[BK-1];
  OM[BK-1] := 1;
_10:
  BI := BI+AY[BK-1]*BF;
  BJ := BJ+BY[BK-1]*BF;
_11:
 end;
for BK:=4 to 7 do
 begin
  BG := H*KSI[BK-1]+P;
  BF := F(W*BG+A);
  BI := BI+AY[BK-1]*BF;
  BJ := BJ+BY[BK-1]*BF;
_12:
 end;
BI := H*BI;
BJ := Abs(H*BJ);
if ( BJ-Z1 ) < 0
 then goto _13
 else if ( BJ-Z1 ) > 0
       then goto _20
       else goto _20;
_13:
P := BH;
E1 := E1+BJ;
J1 := J1+BI;
BF := 1-P;
if ( 1.e0+BF/64-1.e0 ) < 0
 then goto _14
 else if ( 1.e0+BF/64-1.e0 ) > 0
       then goto _16
       else goto _14;
_14:
BG := Abs(F(B))+Abs(BD[2]);
BG := BG*BF;
if ( BG-Z2 ) < 0
 then goto _24
 else if ( BG-Z2 ) > 0
       then goto _15
       else goto _24;
_15:
XA := A+P*W;
J1 := J1*W;
INT := INT+J1;
_QSCOMX.elm1 := XA;
UTQS13(N,5);
goto _50;
_16:
BD[0] := BD[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( BJ-Z1/IntPower(2,7) ) < 0
 then goto _17
 else if ( BJ-Z1/IntPower(2,7) ) > 0
       then goto _18
       else goto _18;
_17:
H := 2*H;
_18:
if ( H-BF ) < 0
 then goto _8
 else if ( H-BF ) > 0
       then goto _19
       else goto _8;
_19:
H := BF;
goto _8;
_20:
H := H/2.e0;
if ( H-SYS051*P ) < 0
 then goto _21
 else if ( H-SYS051*P ) > 0
       then goto _23
       else goto _21;
_21:
if ( P ) < 0
 then goto _22
 else if ( P ) > 0
       then goto _15
       else goto _22;
_22:
if ( H/4 ) < 0
 then goto _15
 else if ( H/4 ) > 0
       then goto _23
       else goto _15;
_23:
BD[2] := BD[1];
OM[1] := 0;
goto _8;
_24:
J1 := J1*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then goto _25;
BA := B;
B := A;
A := BA;
_25:
case U of
 1: goto _30;
 2: goto _35;
end;
_26:
IL := 1;
J := B;
L := A;
E2 := E;
E := 1000;
_27:
B := L+V*X;
if ( (B-J)*X ) < 0
 then goto _29
 else if ( (B-J)*X ) > 0
       then goto _28
       else goto _29;
_28:
B := J;
_29:
U := 1;
goto _5;
_30:
INT := J1;
Q := Abs(J1);
E3 := E1;
_31:
Z := False;
_32:
R := Q;
A := B;
B := L+(B-L)*V;
if ( (B-J)*X ) < 0
 then goto _34
 else if ( (B-J)*X ) > 0
       then goto _33
       else goto _34;
_33:
B := J;
_34:
U := 2;
goto _5;
_35:
INT := INT+J1;
Q := Abs(J1);
E3 := E3+E1;
if ( Q  = 0.0e0  ) and ( R  = 0.0e0 ) 
 then goto _38;
if ( Q-0.999999e0*R ) < 0
 then goto _36
 else if ( Q-0.999999e0*R ) > 0
       then goto _31
       else goto _31;
_36:
S := Q/R;
S := Q*S/(1-S);
if ( S-E2 ) < 0
 then goto _37
 else if ( S-E2 ) > 0
       then goto _31
       else goto _31;
_37:
if (  not ( (Z) ) ) 
 then goto _45;
E3 := E3+S;
_38:
BB := E2*(1+Abs(INT));
if ( E3-BB ) < 0
 then goto _43
 else if ( E3-BB ) > 0
       then goto _39
       else goto _43;
_39:
if ( IL-1 ) < 0
 then goto _40
 else if ( IL-1 ) > 0
       then goto _40
       else goto _41;
_40:
BC := Abs(INT-INT2);
if ( BC-BB ) < 0
 then goto _42
 else if ( BC-BB ) > 0
       then goto _41
       else goto _42;
_41:
INT2 := INT;
EPS := EPS/IntPower(2,7);
IL := 2;
goto _44;
_42:
E3 := BC;
_43:
goto _46;
_44:
A := L;
goto _27;
_45:
Z := True;
goto _32;
_46:
E := E2;
A := L;
B := J;
C := C+INT;
D := C;
if ( Y ) 
 then goto _49;
if ( X+1 ) < 0
 then goto _47
 else if ( X+1 ) > 0
       then goto _48
       else goto _47;
_47:
T := E3;
M := B;
B := K;
X := 1;
goto _26;
_48:
E3 := E3+T;
A := M;
E := 2*E;
_49:
B := K;
XA := B;
INT := D;
if (  not ( (NIS) ) ) 
 then goto _50;
INT := -INT;
_50:
RINT := INT;
end;

end.
